package com.minemaarten.signals.client.gui;

import java.awt.Point;

import net.minecraft.client.resources.I18n;

import com.minemaarten.signals.api.access.ICartHopper.HopperMode;
import com.minemaarten.signals.client.gui.widget.GuiButtonSpecial;
import com.minemaarten.signals.inventory.ContainerBase;
import com.minemaarten.signals.tileentity.TileEntityCartHopper;

public class GuiCartHopper extends GuiContainerBase<TileEntityCartHopper>{

    private GuiButtonSpecial modeButton, engineInteractButton;

    public GuiCartHopper(TileEntityCartHopper te){
        super(new ContainerBase<>(te), te, null);
        field_146999_f = 110;
        field_147000_g = 68;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        modeButton = new GuiButtonSpecial(0, field_147003_i + 5, field_147009_r + 18, 100, 20, "<Mode>");
        modeButton.setTooltipText("<Mode>");

        engineInteractButton = new GuiButtonSpecial(1, field_147003_i + 5, field_147009_r + 40, 100, 20, "<Interact with engine>");
        //  engineInteractButton.setTooltipText("<Interact with engine>");

        addWidget(modeButton);
        addWidget(engineInteractButton);
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();

        HopperMode hopperMode = te.getHopperMode();
        modeButton.field_146126_j = I18n.func_135052_a("signals.gui.cart_hopper.emitRedstoneWhen." + hopperMode.toString().toLowerCase());
        modeButton.setTooltipText(I18n.func_135052_a("signals.gui.cart_hopper.emitRedstoneWhen." + hopperMode.toString().toLowerCase() + ".tooltip"));

        boolean interactEngine = te.isInteractingWithEngine();
        engineInteractButton.field_146126_j = I18n.func_135052_a("signals.gui.cart_hopper.interactWith." + (interactEngine ? "cartEngine" : "cartInventory"));
    }

    @Override
    protected boolean shouldDrawBackground(){
        return false;
    }

    @Override
    protected Point getInvTextOffset(){
        return null;
    }

    @Override
    protected void func_146976_a(float partialTicks, int i, int j){
        drawBackLayer();
        func_73734_a(field_147003_i, field_147009_r, field_147003_i + field_146999_f, field_147009_r + 12, 0xFF222222);
        drawDarkGreyTextCentered(field_147003_i + field_146999_f / 2, field_147009_r, te.func_145838_q().func_149732_F());
        super.func_146976_a(partialTicks, i, j);
    }

}
